//--------------------------------------------------------
//   AECntRDR.C -- Displays " hh:mm:ss:ff " in client area for up to three
//			time code reading boards with their base addresses.
//		    Also prints the AECDLL.DLL Revision Number.  
//--------------------------------------------------------
    //NOTE: WHERE THERE IS A 'WO' IN THE COMMENTS BELOW, IT STANDS FOR
		// 'WINDOWS OVERHEAD'. THE 'WO' CODE HELPS TO DRAW THE
		// WINDOW, UPDATE THE WINDOW, ETC.

#include <windows.h>
#include <winioctl.h>		// in mstools\include dir
#include <stdio.h>
#include <stdlib.h>

#include "AECiNTTC.h"		//PROTOTYPES OF THE AECPC-TC.DLL FUNCTIONS

#define		true	1
#define		false	0
#define		NONE	0x0000
#define		IOR		0x0095
#define		MMR		0x0090
#define		SMART	0x0050
#define		VLTC	0x0050
#define		LTC		0x0098
#define		VITC	0x0093


typedef struct _AECBrdFnd
	{
		WORD	BrdAddr;
		int		BrdCkType;
		WORD	BrdModel;
		BOOL	BrdReads;
		PVOID	PhysAddr;
	} AECBrdFnd, *PAECBrdFnd;


//VARIABLE DEFINITIONS
AECBrdFnd	AecBoard[6];	// hold data for up to six time code boards
							// that are found (if they are installed).
int		boardNum, BoardsFound;			// number of boards found in registry
int		aecint;
int		i1, i2, i3;
char	hhmmssff[12];	    //data string to hold formated unpacked dataC
char	hhmmssffx[30];
char	charStr[20], rev[2];//character string to hold data sent to screen

WORD	B_Addr;
LPSTR	lpPassToAECDLLrev, lpStr1;	// typedef  char FAR*	LPSTR  

//Function Prototypes
int		FindAllBoards(void);
void	RecordSmart(int, WORD);
long	WINAPI WndProc (HWND, UINT, UINT, LONG) ;
	    //window proceedure (WndProc) PROTOTYPE

HDC			hdc;				// WO
PAINTSTRUCT	ps;					// WO
RECT		rect;				// WO
MSG			msg;	//Global message structure that several
				    // functions use as a parameter

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int WINAPI WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
    {

    static char szAppName[] = "NT TEST AP" ;
    HWND	 hwnd ;
    WNDCLASS	 wndclass ;
    lpPassToAECDLLrev = (LPSTR) &rev;

	
	boardNum = AEC_PCTC_GET_NUMBER_OF_DEVICES ();	//# use when dll

    if (!hPrevInstance) //WO used to allow the creation of only one wndclass
          {
	  wndclass.style	 = CS_HREDRAW | CS_VREDRAW ;		// WO
	  wndclass.lpfnWndProc	 = WndProc ;					// WO
	  wndclass.cbClsExtra	 = 0 ;							// WO
	  wndclass.cbWndExtra	 = 0 ;							// WO
	  wndclass.hInstance	 = hInstance ;					// WO
	  wndclass.hIcon	 = LoadIcon (NULL, IDI_APPLICATION) ;	// WO
	  wndclass.hCursor	 = LoadCursor (NULL, IDC_ARROW) ;	// WO
	  wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;	// WO
	  wndclass.lpszMenuName  = NULL ;						// WO
	  wndclass.lpszClassName = szAppName ;					// WO

	  RegisterClass (&wndclass) ;							// WO
	  }

    hwnd = CreateWindowEx (WS_EX_TOPMOST, //ext.window style(always on top)
		    szAppName,				// address of registered class name
		    "AEC_NTTC READER TEST",						// window text
		    WS_THICKFRAME | WS_SYSMENU,					// window style
		    10,								// initial x position
		    30,								// initial y position
		    0x110,							// window width
		    0x58,							// window height
                    NULL,                   // parent window handle
                    NULL,                   // window menu handle
                    hInstance,              // program instance handle
		    NULL) ;							// creation parameters


//--------------
	BoardsFound = FindAllBoards();


    ShowWindow (hwnd, nCmdShow) ;	// WO part of the window creation
    UpdateWindow (hwnd) ;			// WO part of the window creation


    do					// loop until "close"
	{
		TranslateMessage (&msg) ;				// WO
		DispatchMessage (&msg) ;				// WO
		InvalidateRect ( hwnd, NULL, 0 );
	}
    while (GetMessage (&msg, NULL, 0, 0));		//WO
    TranslateMessage (&msg) ;					// WO
    DispatchMessage (&msg) ;					// WO

    return msg.wParam ; 						// WO
    }

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		    //WINDOW PROC
long WINAPI WndProc (HWND hwnd, UINT message, UINT wParam,
                                                          LONG lParam)
     {
     switch (message)								// WO
          {
	  case WM_PAINT:
		  hdc = BeginPaint (hwnd, &ps) ;			// WO
		  GetClientRect (hwnd, &rect) ;				// WO

		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		  //print to the screen the data being read by the time code 
		  //	board(s) that has been found (if any). (up to 3 board's 
		  //	reader data will automaticly be displayed)
		if ( BoardsFound != 0 )
		{
			if ( AecBoard[0].BrdReads == TRUE)
			{
				B_Addr = AecBoard[0].BrdAddr;
				aecint = AEC_PCTC_READ_ASC_TB (charStr, &B_Addr);
				DrawText (hdc,			//PRINT IN THE WINDOW
					charStr,
					aecint,
					&rect,
					DT_SINGLELINE | DT_CENTER | DT_VCENTER);
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"%X",
					B_Addr),
					&rect,
					DT_SINGLELINE | DT_CENTER  );

			}
		}

		if ( BoardsFound > 1 )
		{
			if ( AecBoard[1].BrdReads == TRUE)
			{
				B_Addr = AecBoard[1].BrdAddr;
				aecint = AEC_PCTC_READ_ASC_TB (charStr, &B_Addr);
				DrawText (hdc,			//PRINT IN THE WINDOW
					charStr,
					aecint,
					&rect,
					DT_SINGLELINE  | DT_VCENTER);
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"%X",
					B_Addr),
					&rect,
					DT_SINGLELINE );

			}
		}

		if ( BoardsFound > 2 )
		{
			if ( AecBoard[2].BrdReads == TRUE)
			{
				B_Addr = AecBoard[2].BrdAddr;
				aecint = AEC_PCTC_READ_ASC_TB (charStr, &B_Addr);
				DrawText (hdc,			//PRINT IN THE WINDOW
					charStr,
					aecint,
					&rect,
					DT_SINGLELINE | DT_RIGHT | DT_VCENTER);
				DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
					hhmmssff,
					wsprintf (hhmmssff,"%X",
					B_Addr),
					&rect,
					DT_SINGLELINE | DT_RIGHT );

			}
		}
		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		// print the dll rev info and the number of boards that the
		// find function has returned and the number of boards that 
		// the dll has registered.
		aecint = AEC_PCTC_GET_DLL_INFO (lpPassToAECDLLrev);
		//uses the AECDLL.DLL.  It passes the DLL revision 
		DrawText (hdc,			//PRINT THE DLL REV TO WINDOW
		       //rev,
		       //aecint,
			   hhmmssff,
			   wsprintf (hhmmssff,"DLL Rev. %c%c",
		 	   rev[0], rev[1]),
		       &rect,
		       DT_SINGLELINE | DT_CENTER | DT_BOTTOM);
			//print the 'boardNum'
		DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
			hhmmssff,
			wsprintf (hhmmssff,"%X",
			boardNum),
			&rect,
			DT_SINGLELINE | DT_BOTTOM );
			//print the 'BoardsFound'
		DrawText (hdc,		//FORMAT TEXT FOR THE WINDOW
			hhmmssff,
			wsprintf (hhmmssff,"%X",
			BoardsFound),
			&rect,
			DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);

		
		EndPaint (hwnd, &ps) ;					//WO		boardNum
	       return 0 ;								//WO

	  case WM_DESTROY:								// WO
	       PostQuitMessage (0) ;					// WO
	       return 0 ;								// WO
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;	// WO
     }


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Call the 'Check_board' function for each of the possible addresses
//	that a time code board could be at and then store the board Type and
//	determine if the board has reading ability (some Smart boards are
//	generate only).  
// Returns the number of boards that where found.
//
//	PC-LTC/IOR BOARDS HAVE STANDARD ADDRESS JUMPER SETTINGS OF...
//	(port mapped)	200h, 220h, 280h, 2A0h, 300, 320h, 380h, & 3A0h
//	PC-LTC/MMR ... C0(00)h, C4(00)h, C8(00)h, CC(00)h, D0(00)h, D4(00)h
//	(memory mapped)		D8(00)h, & DC(00)h.
//	PC-LTC/(RDR, GEN, RG1) & ALL PC-VITC/XXX & ALL PC-VLTC/XXX HAVE
//		ADDRESS... CC00h, CD00h, CE00h, CF00h, DC00h, DD00h, DE00h, & DF00h
// The 'actual' address that the memory mapped boards are 'physically' 
//	mapped to is four bits higher than the jumper's lable. 
//	(ie: CC00 -> CC000h address
int	  FindAllBoards(void)
{
	WORD	BrdAddr;
	int		CkType, FoundCnt;

//look for and IOR return value at the possible IOR addresses
	FoundCnt = 0x00;
	BrdAddr = 0x200;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);	// returns a 0(none), 
												// 1(IOR), 2(MMR), 3(Smart)		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x220;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x280;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x2A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x300;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x320;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x380;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}
	BrdAddr = 0x3A0;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		AecBoard[FoundCnt].BrdReads = TRUE;
		FoundCnt++;
	}

//look for and MMR/Smart return value at the possible memory map addresses
	BrdAddr = 0xC000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xC800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD000;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD400;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xD800;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDC00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xCF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDD00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDE00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	BrdAddr = 0xDF00;
	CkType = AEC_PCTC_CHECK_BOARD (&BrdAddr);		
	if	(CkType != 0 )
	{
		AecBoard[FoundCnt].BrdAddr = BrdAddr;
		AecBoard[FoundCnt].BrdCkType = CkType;
		if (CkType == 2 )
		{
			AecBoard[FoundCnt].BrdReads = TRUE;
			FoundCnt++;
		}
		else if (CkType == 3 )
		{
			RecordSmart(FoundCnt, BrdAddr);
			FoundCnt++;
		}	
	}
	return FoundCnt;
}


// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void	RecordSmart(int Cnt, WORD BrdAddr)
{
	WORD		Addr, OffsetE0, OffsetE1, OffsetE2, OffsetEF;
	BYTE		bId0, bId1, bId2, bType; // bytes from 3E0, 3E1, 3E2, 3EF.
	BYTE		bCom, bRet;
	BOOL		ok;
	
	Addr =  BrdAddr;
	OffsetE0 = 0x3E0;
	OffsetE1 = 0x3E1;
	OffsetE2 = 0x3E2;
	OffsetEF = 0x3EF;
	
	// read the smart board type id byte ( 0x50 VLTC, 0x93 VITC, 0x98 LTC)
	if (ok = AEC_PCTC_READ_1BYTE (&bType, &OffsetEF, &Addr))	
		AecBoard[Cnt].BrdModel = (WORD)bType;

	// read the board id bytes to see if this board reads tc.
	ok = AEC_PCTC_READ_1BYTE (&bId0, &OffsetE0, &Addr);
	ok = AEC_PCTC_READ_1BYTE (&bId1, &OffsetE1, &Addr);
	ok = AEC_PCTC_READ_1BYTE (&bId2, &OffsetE2, &Addr);
		
	if ((bId0 == 'R' ) || (bId1 == 'R' ) || (bId2 == 'R' ))
	{
		AecBoard[Cnt].BrdReads = TRUE;
		// now make sure that the board is in reader mode
		bCom = 0x16; // idle command  ltc/vitc/vltc
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);
		if (bType ==0x50)
			bCom = 0x23; // dual reader mode command vltc board
		else bCom = 0x10; // reader mode command ltc/vitc boards
			
		ok = AEC_PCTC_SEND_COMMAND(&bCom, &bRet, &Addr);

	}
	else AecBoard[Cnt].BrdReads = FALSE;
	//no return for 'void'
}
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

