;-----------------------------------------------------------------------;
;      SAMPLE ASSEMBLY SOURCE CODE FOR LINKING TO THE AECPC-TC.DLL	;
;DLL_EXAM.ASM			'ASMEXWIN'				;
;-----------------------------------------------------------------------;
;	THIS CODE USES ONLY A FEW OF THE PROCEDURES THAT THE AECDLL	;
;   CONTAINS, BUT IT DOES ESTABLISH A LINK AND WILL WORK AS AS SIMPLE	;
;   EXAMPLE AS HOW TO ACCESS THE AECDLL VIA AN ASSEMBLY LANGUAGE SOURCE ;
;   CODE.   THE CODE HERE ESTABLISHES A SMALL WINDOW AND THEN WRITES	;
;   THE TIME CODE THAT IS READ FROM THE PC-VLTC BOARD INTO THE CLIENT	;
;   AREA IN HH:MM:SS:FF FORMAT ALONG WITH THE AECDLL REVISION NUMBER	;
;									;
;   03/06/95  TSR							;
;-----------------------------------------------------------------------;
		.model	small, pascal, nearstack
		.286
			 ; NOTE:
			 ; AFLAGS_G  = /W2 /WX	/DMODEL=small
			 ; this line must be inserted into the PWB Makefile
			 ; line that has the AFLAGS_G = ...    in order to
			 ; define the MODEL
		?WINPROLOGUE = 1
		include win.inc                 ; Converted from WINDOWS.H
		include AECDLL1.INC		; AECDLL.DLL ASM definitions
;----------------------------------------------------------------------------;
;		  Function Prototypes & Variable Definitions		     ;
;----------------------------------------------------------------------------;

WinMain         PROTO PASCAL, hInstance:HANDLE,  hPrevInstance:HANDLE,
			lpszCmdLine:LPSTR, nCmdShow:SWORD
WndProc         PROTO FAR PASCAL,  :HWND, :WORD, :SWORD, :SDWORD

extern __astart:proc		; When Windows load an app, it expects astart
				; to have the necessary start-up code. We get
				; astart from APPENTRY.ASM
;----------------------------------------------------------------------------;
;                             Numeric Equates                                ;
;----------------------------------------------------------------------------;
NULL	    EQU     00h
;----------------------------------------------------------------------------;
;                               Data Segments                                ;
;----------------------------------------------------------------------------;
		.CONST			;CONSTANTS

szAppName	SBYTE	"ASMtimeCODEdemo",0
szSysIcon	SBYTE	"IDI_APPLICATION",0  ;"SysIcon",0

		.data

;TaskHeader	BYTE	16 DUP (0)
TC		SBYTE	"00:00:00:00",0
Start_Time	SBYTE	    'xxxx',0
BrdAddr 	WORD	    0
DPRAM_40	WORD	    0
regnum		WORD	    0
ready		BYTE	    0
command 	BYTE	    0
intcode 	byte	    0
Cmdbyte 	byte	    1
rev		SBYTE	    'xx',0     ;should be 'A1' 03/06/95 when run
ps		PAINTSTRUCT { }
rect		RECT	    { }
hdc		HDC	    ?
;----------------------------------------------------------------------------;
;                               Code Segment                                 ;
;----------------------------------------------------------------------------;
		.code

;----------------------------------------------------------------------------;
;                               WinMain                                      ;
;----------------------------------------------------------------------------;
;                                                                            ;
; Main routine called by Windows in program start. If no previous instances, ;
; sets up a window class and registers it, then sets up the message loop.    ;
;                                                                            ;
;----------------------------------------------------------------------------;

WinMain 	PROC,	 hInstance:HANDLE,  hPrevInstance:HANDLE,
			lpszCmdLine:LPSTR, nCmdShow:SWORD
		LOCAL   msg:MSG, wndclass:WNDCLASS

		;Local variables: msg: message to be used in the message loop
		;		   wndclass: temp. to store window class

	PUSH	DI
	MOV	DI,OFFSET Start_Time
	MOV	BYTE PTR [DI+3],23h	    ;store the start time-HH
	MOV	BYTE PTR [DI+2],59h	    ;MM
	MOV	BYTE PTR [DI+1],45h	    ;SS
	MOV	BYTE PTR [DI],08h	    ;FF
	POP	DI
	MOV	AX,0040h
	MOV	DPRAM_40,AX
	MOV	AX,0CC00h		    ;put the board address here
	MOV	BrdAddr,AX
	MOV	regnum,03FDH	    ;DPRAM address that the 'READ1' will read

	MOV	AL,2		    ; reset code
	MOV	command,AL
       INVOKE AEC_PCTC_SEND_COMMAND, ADDR command, ADDR intcode, ADDR BrdAddr
			;resets the AEC board
;
;--- Check for previous instances
;
		.IF (hPrevInstance == 0)
				   ; initialize (fill) the wndclass structure
			LEA	 di, wndclass	 ; because we use a NEARSTACK,
			ASSUME	di:PTR WNDCLASS  ; ss=ds

			MOV	WORD PTR [di].lpfnWndProc,   LROFFSET WndProc
			MOV	WORD PTR [di].lpfnWndProc+2, SEG WndProc

			XOR	AX,AX
			MOV	[di].cbWndExtra,AX
			MOV	[di].cbClsExtra, AX
			MOV	AX,CS_HREDRAW OR CS_VREDRAW
			MOV	[di].style,AX

			INVOKE	LoadIcon, NULL, IDI_APPLICATION
				    ;hInstance, ADDR szSysIcon
				    ; LoadIcon(NULL, IDI_APPLICATON)
			MOV	[di].hIcon, AX

			MOV	AX, hInstance
			MOV	[di].hInstance, AX

			INVOKE  LoadCursor, NULL, IDC_ARROW
			MOV	[di].hCursor, AX

			MOV	[di].hbrBackground, COLOR_WINDOW +1

			XOR	AX, AX
			MOV	WORD PTR [di].lpszMenuName,   AX
			MOV	WORD PTR [di].lpszMenuName+2, AX

			MOV	WORD PTR [di].lpszClassName, OFFSET szAppName
			MOV	WORD PTR [di].lpszClassName+2, ds

			INVOKE  RegisterClass, di
			.IF (AX == 0)
				MOV	AX, FALSE
				JMP	doRet
			.ENDIF

			ASSUME  di:NOTHING        

		.ENDIF     ;--- End of IF (hPrevInstance == 0)


		  ;API CALL
	INVOKE	CreateWindowEx, WS_EX_TOPMOST, ADDR szAppName,
			    ADDR szAppName,
			    WS_THICKFRAME OR WS_SYSMENU,
			    0, 0, 0B0H, 030H,
			    NULL, NULL, hInstance, NULL

	MOV	si, AX
	INVOKE	ShowWindow, si, nCmdShow		     ;API CALL
	INVOKE	UpdateWindow, si			     ;API CALL

	INVOKE	AEC_PCTC_GET_DLL_INFO, ADDR rev	 ;get the AECDLL.Dll Rev.

	MOV	AL,20h
	MOV	command,AL		    ;run Gen and LTC together
      INVOKE AEC_PCTC_SEND_COMMAND, ADDR command, ADDR intcode, ADDR BrdAddr

	MOV	AL,25h
	MOV	command,AL		    ;IDLE board
   INVOKE   AEC_PCTC_SEND_COMMAND, ADDR command, ADDR intcode, ADDR BrdAddr

   INVOKE AEC_PCTC_WRITE_4BYTES, ADDR Start_Time, ADDR DPRAM_40, ADDR BrdAddr
					    ;write the starting time to memory
	MOV	AL,41h
	MOV	command,AL		    ;Load time code generator
       INVOKE AEC_PCTC_SEND_COMMAND, ADDR command, ADDR intcode, ADDR BrdAddr

	MOV	AL,48h
	MOV	command,AL		    ;Start Gen
       INVOKE AEC_PCTC_SEND_COMMAND, ADDR command, ADDR intcode, ADDR BrdAddr

	INVOKE	GetMessage,    ADDR msg, NULL, 0, 0	     ;API CALL
		 ;returns 'zero' only when 'WM_QUIT'

;---- Message Loop

	CMP AX, 00H	; AX = 0 WHEN 'WM_QUIT'
	JE  GetOut	; JUMP OUT OF LOOP AND EXECUTE EXIT CODE BELOW

lpout1:	    INVOKE	TranslateMessage, ADDR msg	     ;API CALL
	    INVOKE	DispatchMessage,  ADDR msg	     ;API CALL
lpin1:	      INVOKE AEC_PCTC_READ_1BYTE, ADDR ready, ADDR regnum, ADDR BrdAddr
		CMP	ready,0
		JE	NOT_RDY
		    INVOKE  AEC_PCTC_GET_INTCODE, ADDR Cmdbyte, ADDR intcode, ADDR BrdAddr
		    CMP     intcode,13H   ;'13h'is 'frame change' interupt
		    JNE     NOT_RDY
			INVOKE	AEC_PCTC_READ_ASC_TB, ADDR TC, ADDR BrdAddr
			INVOKE	InvalidateRect, si, NULL, 0  ;API CALL

NOT_RDY:	INVOKE	 PeekMessage, ADDR msg, NULL, 0, 0, PM_NOREMOVE
		   ;PeekMessage retuns False (0)for 'NONE' found  API CALL
		CMP AX, 00H
		JE  lpin1
lpout2:	    INVOKE  GetMessage,    ADDR msg, NULL, 0, 0 	 ;API CALL
	    CMP AX, 00H	; AX = 0 WHEN 'WM_QUIT'
	    JNE	lpout1	; JUMP BACK TO LOOP IF NOT WM_QUIT

GetOut: INVOKE	AEC_PCTC_UNINSTALL_BOARD, ADDR BrdAddr

	INVOKE	TranslateMessage, ADDR msg			;API CALL
	INVOKE	DispatchMessage,  ADDR msg			;API CALL
	MOV	AX, msg.wParam
doRet:
		ret

WinMain         ENDP

;****************************************************************************;
;----------------------------------------------------------------------------;
;                                  WndProc                                   ;
;                                                                            ;
;									     ;
;		  A 'Close Window' will get us out.			     ;
;----------------------------------------------------------------------------;

WndProc         PROC FAR PASCAL, hWnd:HWND, iMessage:WORD, wParam:SWORD,
				 lParam:SDWORD
		; Windows gives us: the handle of the Window, the Message ID,
		; and two parameters for the message

		.IF (iMessage == WM_PAINT)
			INVOKE	BeginPaint, hWnd, ADDR ps	    ;API CALL
			MOV	hdc,AX
			INVOKE	GetClientRect, hWnd, ADDR rect	    ;API CALL
			INVOKE	DrawText, hdc, ADDR rev, -1, ADDR rect,
				    DT_SINGLELINE		    ;API CALL
			INVOKE	DrawText, hdc, ADDR TC, -1, ADDR rect,
				    DT_SINGLELINE OR DT_CENTER OR DT_VCENTER
			INVOKE	EndPaint, hWnd, ADDR ps 	    ;API CALL

		.ELSEIF (iMessage==WM_DESTROY)
			INVOKE	PostQuitMessage, 0		    ;API CALL

		.ELSE
doDefault:
			INVOKE	DefWindowProc, hWnd, iMessage, wParam,lParam
			jmp doRet

		.ENDIF

		mov ax, 0
		cwd
doRet:
		ret

WndProc         ENDP


		END  __astart   ; so that the code of the application will
				; start with the Windows start-up code

;***************************************************************************;
